#include <bits/stdc++.h>

using namespace std;

bool sortir(pair<int, int> a, pair<int, int> b) {
	return a.second>b.second;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n, q; cin >> n >> q;
	int niz[n];
	for (int i = 0;i<n;i++) cin >> niz[i];
	for (int k = 0; k<q; k++) {
		map <int, int> frekvencija;
		for (int i = 0; i<n; i++) {
			frekvencija[niz[i]] = 0;
		}
		int l, d; cin >> l >> d;
		l--;d--;

		
		for (int i = l; i<=d; i++) {
			frekvencija[niz[i]]++;
		}
		vector<pair<int,int> > viktor;
		for (auto a : frekvencija) viktor.push_back(a);
		sort(viktor.begin(), viktor.end(), sortir);
		cout << viktor[0].second << '\n';
	}
/*
5 2
16 8 32 4 16
1 5
1 3

*/

return 0;
}